using namespace System;

#ifndef GIFHDRH
#define GIFHDRH

#define MAXCOLORMAPSIZE	256
#define CM_RED	0
#define CM_GREEN 1
#define CM_BLUE 2
#define UCHAR unsigned char
#define MAX_LZW_BITS	12

#define INTERLACE	0x40
#define LOCALCOLORMAP 0x80
#define BitSet(byte,bit) (((byte) & (bit))==(bit))
#define ReadOK(file,buffer,len) (fread(buffer,len,1,file)!=0)
#define LM_to_uint(a,b)	(((b)<<8)|(a))

typedef short int		code_int;	/* was int */
typedef long int		count_int;
typedef unsigned char pixval;


static void ReadGIF (FILE*fd);
static int ReadColorMap (FILE *fd, int number, UCHAR buffer[3][MAXCOLORMAPSIZE]);
static int DoExtension (FILE *fd,int label);
static int GetDataBlock (FILE *fd, UCHAR *buf);
static int GetCode (FILE *fd, int code_size, int flag);
static int LZWReadByte (FILE *fd,int flag, int  input_code_size);
static BOOL ReadImage(	FILE *fd, BYTE *bigMemBuf, int width, int height, UCHAR cmap[3][MAXCOLORMAPSIZE], int interlace);

#endif // GIFHDRH
//////////
//
//

class GIFFile 
{

public:

	GIFFile();
	~GIFFile();

	// read to RGB
	Byte* GIFReadFileToRGB(char* path, 
							UINT *width, 
							UINT *height);

	// find size of file
	void GIFGetDimensions(char* path, 
							UINT *width, 
							UINT *height);

private:
	void ShowErrorMessage(String^ s);

	void BumpPixel (  );
	int GIFNextPixel ( );
	void Putword ( int w, FILE* fp );
	void output ( code_int code );
	void cl_block (  );
	void cl_hash ( count_int hsize );
	void writeerr (  );
	void char_init (  );
	void char_out ( int c );
	void flush_char (  );
};

