#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <windows.h>
#include "giffile.h"

#include "in_gif.h"

namespace image_loader
{
	IntPtr image_loader::Load_Image(String^ filename, IntPtr ptr, IntPtr size, IntPtr buffer)
	{
		int width, height;
		char* fname = StringToCharstring(filename);

		GIFFile gif;
		Byte* data = gif.GIFReadFileToRGB(fname, (UINT*)&width, (UINT*)&height);
		*(int*)(void*)size = 1;
		*(int*)(void*)ptr = 1;
		*((Byte**)(void*)buffer) = data;
		delete [] fname;

		if (!data) return IntPtr(0);

		xml_node^ t;
		xml_node^ image_description = gcnew xml_node( nullptr, "OutputImage", "", "" );
		image_description->children.Add( gcnew xml_node(image_description, "Width", "", width.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Height", "", height.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Stride", "", (((width * 3 + 3) / 4) * 4).ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Packed", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "Interleaved", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "ChannelCount", "", "3") );
		image_description->children.Add( gcnew xml_node(image_description, "PixelSize", "", "24") ); // in bits
		image_description->children.Add( gcnew xml_node(image_description, "Data", "", ((unsigned int)(void*)data).ToString()) );
		image_description->children.Add( t = (gcnew xml_node(image_description, "ChannelsBitAllocation", "", "") ) );
		t->children.Add( gcnew xml_node( t, "Channel0", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel1", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel2", "", "8" ) );

		return (IntPtr)((void*)(image_description->XML_Tree_Marshal()));
 	}

	IntPtr image_loader::GetImageProperties(String^ filename)
	{
		int width, height;
		char* fname = StringToCharstring(filename);

		GIFFile gif;
		gif.GIFGetDimensions(fname, (UINT*)&width, (UINT*)&height);
		delete [] fname;

		if (width == -1) return IntPtr(0);

		xml_node^ t;
		xml_node^ image_description = gcnew xml_node( nullptr, "OutputImage", "", "" );
		image_description->children.Add( gcnew xml_node(image_description, "Width", "", width.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Height", "", height.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Stride", "", (((width * 3 + 3) / 4) * 4).ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Packed", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "Interleaved", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "ChannelCount", "", "3") );
		image_description->children.Add( gcnew xml_node(image_description, "PixelSize", "", "24") ); // in bits
		image_description->children.Add( gcnew xml_node(image_description, "Data", "", "0") );
		image_description->children.Add( t = (gcnew xml_node(image_description, "ChannelsBitAllocation", "", "") ) );
		t->children.Add( gcnew xml_node( t, "Channel0", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel1", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel2", "", "8" ) );

		return (IntPtr)((void*)(image_description->XML_Tree_Marshal()));
	}
}

